
// -----------------------------------------------------------
//                     Horizontal Mirror
// -----------------------------------------------------------

function mirror_horizontal_onDraw(me, eventInfo)
{
    // define the context 2D
    // "me" refer to canvas widget with OnDraw event triggered        
    var ctx = me.context2d;
    
    // img refer to the image widget containing exor_logo.png
    var img = page.getWidget("logo");
    
    // save current status of context
    ctx.save(); 

    // moving canvas context to right by the width of img
    ctx.translate(img.width,0);
    // flip on left
    ctx.scale(-1,1);           
    // draw the content of img into the mirrored context
    ctx.drawImage(img,0,0,img.width,img.height);
    
    // restore the previously saved status of context (remove applied transformations)
    ctx.restore();    
}

// -----------------------------------------------------------
//                     Vertical Mirror
// -----------------------------------------------------------

function mirror_vertical_onDraw(me, eventInfo)
{
    // define the context 2D
    // "me" refer to canvas widget with OnDraw event triggered        
    var ctx = me.context2d;

    // img refer to the image widget containing exor_logo.png 
    var img = page.getWidget("logo");
    
    // save current status of context
    ctx.save();

    // moving canvas context up by the height of img        
    ctx.translate(0,img.height);
    // flip down
    ctx.scale(1,-1);

    // draw the content of img into the mirrored context    
    ctx.drawImage(img,0,0,img.width,img.height);
    
    // restore the previously saved status of context (remove applied transformations)
    ctx.restore();
}

